#Cairo Transparant Window
import pygtk
pygtk.require('2.0')
import cairo
import pango
import gtk
import Images
class CairoWindow():
    def __init__(self):
        pass
        #Parent is used for callback events (neccessary evil)
    def Create(self, parent, mode):
        #Initialise Auxilary Window
        #mode 0 = Orb top  mode 1 = User icon top
        self.parent = parent
        self.mode = mode
        # Create the window itself
        self.aux_window = gtk.Window(gtk.WINDOW_TOPLEVEL)
        self.aux_window.set_default_size(Images.StartButtonTopWidth,Images.StartButtonTopHeight)
        #Set window profile
        self.aux_window.set_skip_taskbar_hint(1)
        self.aux_window.set_skip_pager_hint(1)
        self.aux_window.set_decorated(0)        #Remove window decorations
        self.aux_window.set_app_paintable(True)
        self.aux_window.set_title("")
        self.aux_window.set_keep_above(1)       #Make the orb top always above other windows
        self.aux_window.stick()                 #Make this appear on all desktops
        #Connect redraw-events
        self.aux_window.connect('expose-event', self.Aux_win_screenchange)
        self.aux_window.connect('screen-changed', self.screen_changed)
        self.aux_window.connect('destroy', self.undestroy)
        if self.mode == 0:
            self.aux_window.connect("enter-notify-event", parent.select_box)
            self.aux_window.connect("leave-notify-event", parent.deselect_box)
            self.ev_box2 = gtk.EventBox()
            self.ev_box2.connect("button-press-event",parent.button_press)
            self.ev_box2.set_above_child (0)
            self.ev_box2.set_visible_window(0)
            self.aux_window.add(self.ev_box2)
        #Initial redraw
        self.icon = cairo.ImageSurface
        self.screen_changed(self.aux_window)
        self.aux_window.show_all()
        # Move orb top to the correct location on screen (using a parent callback)
        if self.mode == 0:
            parent.window_moved(self)
        # Not the best way of doing this
        if Images.EnableCompositing == 0:
            self.aux_window.hide()
    
    def screen_changed(self,widget):
        # Screen change event
        screen = widget.get_screen()
        colormap = screen.get_rgba_colormap()
        widget.set_colormap(colormap)
    
    def undestroy(self,event):
        #Callback for user window destroy (i.e. sporadic alt-f4 ing by the user)
        self.parent.auxdestroyed()
    
    def Aux_win_screenchange(self,widget, event):
        if self.icon:
            # Orb Top Screen change event
            cr = self.aux_window.window.cairo_create()
            cr.set_source_rgba(1.0, 1.0, 1.0, 0.0) # Transparent
            cr.set_operator(cairo.OPERATOR_SOURCE)
            # Draw the graphics
            cr.set_source_surface(self.icon, 0, 0)
            cr.paint()
            if self.mode == 2:
                self.aux_window.window.draw_pixbuf(None,self.icon2,0,0,Images.UserIconX,Images.UserIconY)
        
    def move(self,x,y):
        # Relocate the window
        self.aux_window.move(x,y)
    
    def destroy(self):
        # Remove the window
        self.aux_window.destroy()

    def update(self):
        # Update the screen profile on request
        self.screen_changed(self.aux_window)
        
    def updateimage(self,image):
        # Update the graphic being displayed (first image has size priority)
        self.icon = cairo.ImageSurface.create_from_png(image)
        self.w = self.icon.get_width()
        self.h = self.icon.get_height()
        self.aux_window.resize(self.w,self.h)
        
    def updatesecondimage(self,image):
        #self.icon2 = cairo.ImageSurface.create_from_png(image)
        self.icon2 = gtk.gdk.pixbuf_new_from_file_at_size(image, Images.UserImageWidth, Images.UserImageHeight)

            
