# Image Directories and user settings
# Change these to use custom icons/graphics
# Note! For original theme, set panel height to 31
# As of version 1.00, only bottom panel orientation supported!
# ============================================================
# If you want to change any more of the appearance, then you'll need:
# Glade, a good image editor (eg. GIMP), and perhaps some knowledge of
# python. Think about it before you email me with questions!!!!

import gtk
import os
import xml.dom.minidom

#CurrentDirectory = os.path.abspath(os.curdir)
HomeDirectory = os.path.expanduser("~")
#ImageDirectory = "/usr/share/Vista Menu/images/"
ProgramDirectory = "/usr/lib/vistamenu/"
GladeFile = "/usr/lib/vistamenu/main_menu.glade"  
GladeSettingsFile = "/usr/lib/vistamenu/vista-menu-settings.glade"  

def ReloadSettings():
    global Iname,Ename,Isize,Compositing,ListSize,ImageDirectory,Actions, IconTheme, IconDirectory
    #==============================================DO NOT TOUCH THIS!!
    XMLSettings = xml.dom.minidom.parse(ProgramDirectory+"Settings.xml")
    XBase = XMLSettings.childNodes[0].childNodes[1]
    Iname = XBase.childNodes[1].attributes["Iname"].value
    Ename = XBase.childNodes[1].attributes["Ename"].value
    Isize = XBase.childNodes[3].attributes["IconSize"].value
    Compositing = XBase.childNodes[5].attributes["Compositing"].value
    ListSize = XBase.childNodes[7].attributes["ListSize"].value
    Theme = XBase.childNodes[9].attributes["Theme"].value
    ImageDirectory = "/usr/share/vistamenu/Themes/"+str(Theme)+"/"
    Actions = []
    Actions.append(XBase.childNodes[11].attributes["B1"].value)
    Actions.append(XBase.childNodes[11].attributes["B2"].value)
    Actions.append(XBase.childNodes[11].attributes["B3"].value)
    Actions.append(XBase.childNodes[11].attributes["B4"].value)
    Actions.append(XBase.childNodes[11].attributes["B5"].value)
    Actions.append(XBase.childNodes[11].attributes["B6"].value)
    Actions.append(XBase.childNodes[11].attributes["B7"].value)
    Actions.append(XBase.childNodes[11].attributes["B8"].value)
    Actions.append(XBase.childNodes[11].attributes["B9"].value)
    Actions.append(XBase.childNodes[11].attributes["B10"].value)
    Actions.append(XBase.childNodes[11].attributes["B11"].value)
    Actions.append(XBase.childNodes[11].attributes["B12"].value)
    IconTheme = XBase.childNodes[13].attributes["IconTheme"].value
    IconDirectory = "/usr/share/vistamenu/Icons/"+str(IconTheme)+"/"    
    #================================================================
    global EnableCompositing,BrowserName,EmailName,PG_iconsize,RI_numberofitems
    # Disable if you dont use a compositing window manager
    EnableCompositing = int(Compositing)
    #The text name of the browser to be displayed in the menu
    BrowserName = Iname
    #The text name of the email client to be displayed in the menu
    EmailName = Ename
    #Size of icons in the program list (default is 24)
    PG_iconsize = int(float(Isize))
    #Recent Items Menu
    RI_numberofitems = int(float(ListSize))

ReloadSettings()
#Screen width/height
__screen = gtk.gdk.screen_get_default()
geom = gtk.gdk.Screen.get_monitor_geometry(__screen, 0)
screenwidth = geom.width
screenheight = geom.height

#Basemenu parse (saves the delay everytime the menu is opened)
BaseMenu=""


#Main Start Button
#States:
# 0 = Normal
# 1 = Glowing (mouse-over)
# 2 = Depressed

# Blue glowy orb main
StartButton = (IconDirectory+"start-here.png",
               IconDirectory+"start-here-glow.png",
               IconDirectory+"start-here-depressed.png")
               
# Blue glowy orb top part
StartButtonTop = (IconDirectory+"start-here-top.png",
                     IconDirectory+"start-here-top-glow.png",
                     IconDirectory+"start-here-top-depressed.png",
                     IconDirectory+"start-here-bottom.png",
                     IconDirectory+"start-here-bottom-glow.png",
                     IconDirectory+"start-here-bottom-depressed.png")

# Placement parameters
StartButtonTopWidth = 40
StartButtonTopHeight = 8
StartButtonXOffset = 1
StartButtonYOffset = -7

# Start Menu
StartMenuTemplate = ImageDirectory+"start-menu-template.png"
StartMenuXOffset = -2
StartMenuYOffset = 0

#User Image
UserImageFrame = ImageDirectory+"user-image-frame.png"
DefaultUserImage = IconDirectory+"no-user-image.png"
UserImage = os.getenv('HOME') + "/.face"
if os.path.isfile(UserImage) == 0:
    UserImage=DefaultUserImage
UserImageWidth = 48
UserImageHeight = 48
UserIconX = 9
UserIconY = 6
UserIconFrameOffsetX = 300
UserIconFrameOffsetY = 6

#Application logo
Applogo = ImageDirectory+"logo.png"

#Web and Email
Browser = IconDirectory+"firefox_icon.png"
Email = IconDirectory+"thunderbird_icon.png"

#Power Lock and Aux Buttons
PowerButton = ImageDirectory+"power_button.png"
PowerButtonSel = ImageDirectory+"power_button_sel.png"
LockButton = ImageDirectory+"lock_button.png"
LockButtonSel = ImageDirectory+"lock_button_sel.png"
AuxButton = ImageDirectory+"aux_button.png"
AuxButtonSel = ImageDirectory+"aux_button_sel.png"

#Right hand side menu
M_Home = [ImageDirectory+"m_home_sel.png",IconDirectory+"m_home_pic.png"]
M_Documents = [ImageDirectory+"m_documents_sel.png",IconDirectory+"m_documents_pic.png"]
M_Pictures = [ImageDirectory+"m_pictures_sel.png",IconDirectory+"m_pictures_pic.png"]
M_Music = [ImageDirectory+"m_music_sel.png",IconDirectory+"m_music_pic.png"]
M_Games = [ImageDirectory+"m_games_sel.png",IconDirectory+"m_games_pic.png"]
M_Search = [ImageDirectory+"m_search_sel.png",IconDirectory+"m_search_pic.png"]
M_RecentItems = [ImageDirectory+"m_recentitems_sel.png",IconDirectory+"m_recentitems_pic.png"]
M_Computer = [ImageDirectory+"m_computer_sel.png",IconDirectory+"m_computer_pic.png"]
M_Network = [ImageDirectory+"m_network_sel.png",IconDirectory+"m_network_pic.png"]
M_Connect = [ImageDirectory+"m_connect_sel.png",IconDirectory+"m_connect_pic.png"]
M_ControlPanel = [ImageDirectory+"m_controlpanel_sel.png",IconDirectory+"m_controlpanel_pic.png"]
M_Defaults = [ImageDirectory+"m_defaults_sel.png",IconDirectory+"m_defaults_pic.png"]
M_Help = [ImageDirectory+"m_help_sel.png",IconDirectory+"m_help_pic.png"]

PG_buttonwidth = 228

#X and Y coordinates of the frame that holds the program group buttons
PG_buttonframe = [9,122]
#Width and Height of same object  NB, this is 385 when (programs >>) is to show
PG_buttonframedimensions = [250,412]


#GLOBAL DEFINITIONS (NO USER SERVICABLE PARTS BEYOND THIS LINE)
M_CurrentIconSet = ""
elist = []
ebuttonnamelist = []
ebuttoniconlist = []
etypelist = []
        
