# Vista_Menu Panel Applet (the blue orb thingie)

import pygtk
pygtk.require('2.0')
import gtk
import gtk.glade
import sys
import gobject
import gnomeapplet
import gnome.ui
import os.path
import re
import Images
from Vista_Menu_Main import Main_Menu, ConstructMainMenu
from Cairo_Window import CairoWindow
import Globals as pglobals

class VistaMenu(gnomeapplet.Applet):
    global Button_state
    def __init__(self,applet,iid):
        #Initialise Menus
        ConstructMainMenu()
        #self.__gobject_init__()
        self.timeout_interval = 200
        self.tooltip_text = "Vista like menu for the Gnome desktop"
        # Initialise Gnome
        gnome.init("Vista Menu", "0.1")
        # Initialise Button
        self.Button_state = 0
        self.screenstate = 0
        # 0 = No change  1 = Mouse over  2 = Depressed
        # Initialise GTK Interface
        self.propxml="""
        <popup name="button3">
        <menuitem name="Item 1" verb="Props" label="_Preferences..." pixtype="stock" pixname="gtk-properties"/>
        <menuitem name="Item 2" verb="About" label="_About..." pixtype="stock" pixname="gnome-stock-about"/>
        <menuitem name="Item 3" verb="Edit" label="_Edit Menus..." pixtype="stock" pixname="alacarte"/>
        </popup>
	    """
        
        self.verbs = [ ( "Props", self.properties ),
                       ( "About", self.about_info ),
                       ( "Edit", self.edit_menus)  
	             ]
        
        self.applet = applet
        self.orientation = self.applet.get_orient()
        # Frame for custom placement of objects
        self.Main_icon_box = gtk.Fixed()
        self.applet.add(self.Main_icon_box)
        # Hook events
        self.ev_box = gtk.EventBox()
        self.ev_box.connect("button-press-event",self.button_press)
        self.ev_box.connect("enter-notify-event", self.select_box)
        self.ev_box.connect("leave-notify-event", self.deselect_box)
        self.ev_box.set_visible_window(0)
        # FIXME: Add event for when applet is moved on panel to enable orb top to follow!!!
        # This is currently set to reorientate itself whenever it is clicked as a temp workaround.
        #self.applet.connect("property-change-event",self.window_moved)
        # Place GTK Image
        self.Main_icon_box.put(self.ev_box,-1,-1)
        self.image_icon = gtk.Image()
        self.image_icon.set_from_file(Images.StartButton[self.Button_state])
        # Add Image to event object
        self.ev_box.add(self.image_icon)
        #Timeout signal
        gobject.timeout_add(self.timeout_interval,self.timeout_callback, self)
        #Destroy signal
        applet.connect("destroy",self.cleanup)
        if Images.EnableCompositing == 1:
            #Create auxiliary window (CAIRO)
            self.aux = CairoWindow()
        #Show all created windows
        applet.show_all()

    def auxdestroyed(self):
        #Respawn point for the aux window if it has been Alt-F4ed
        if Images.EnableCompositing == 1:
            #Used in this instance for providing delay for window to be created
            self.aux = CairoWindow()
            self.aux.Create(self, 0)     #Create the orb top
            self.aux.updateimage(Images.StartButtonTop[self.Button_state + self.screenstate])
            

    def button_press(self,widget,event):
        if event.button == 1:
            # Remove this next line when orb top repositioning on widget move is fixed
            if Images.EnableCompositing == 1:
                self.window_moved(self.aux)
            if self.Button_state == 2:
                self.Button_state = 1
                self.hwg.destroy()
            else:
                self.Button_state = 2
                self.Redraw_graphics(event.window)
                self.ShowMenu()
                self.Button_state = 0
                
            self.Redraw_graphics(event.window)
        elif event.button == 3:
            self.create_menu()
            
            
    def create_menu(self):
        self.applet.setup_menu(self.propxml,self.verbs,None)
            
    def about_info(self,event,data=None):
        self.Applogo = gtk.gdk.pixbuf_new_from_file(Images.Applogo)
        about = gnome.ui.About("Vista Menu",pglobals.version,"GPL","Vista like start menu for the GNOME desktop.",["Chris Hughes (aka. qb89dragon) <hughescih@hotmail.com>", "Feel free to send the dragon food and money. He is always hungry."],["Nobody."],"Nobody yet...", self.Applogo)
        about.show()

    def properties(self,event,data=None):
        os.spawnvp(os.P_WAIT,Images.ProgramDirectory+"Vista-Menu-Settings.py",[Images.ProgramDirectory+"Vista-Menu-Settings.py"])
        Images.ReloadSettings()
        
    def select_box(self,widget,event):
        if self.Button_state == 0:
            self.Button_state = 1
        self.Redraw_graphics(event.window)
        
    def deselect_box(self,widget,event):
        if self.Button_state == 1:
            self.Button_state = 0
        self.Redraw_graphics(event.window)
        
    def Redraw_graphics (self, window):
        self.image_icon.set_from_file(Images.StartButton[self.Button_state])
        if Images.EnableCompositing == 1:
            self.aux.updateimage(Images.StartButtonTop[self.Button_state + self.screenstate])
        self.applet.queue_draw()

    def timeout_callback(self,event):
        if Images.EnableCompositing == 1:
            #Used in this instance for providing delay for window to be created
            self.aux.Create(self, 0)     #Create the orb top
            self.aux.updateimage(Images.StartButtonTop[self.Button_state + self.screenstate])
        
        
    def cleanup(self,event):
        print "cleanup"
        gtk.main_quit()
        self.aux.destroy()
    
    def edit_menus(self,event, data=None):
        os.spawnvp(os.P_WAIT,"alacarte",["alacarte"])
        ConstructMainMenu()

    def ShowMenu(self):
            # Display the start menu!!!
            self.hwg = Main_Menu()
            origin = self.applet.window.get_origin()
            self.hwg.setup(origin[0], origin[1])
            Images.SavedOriginState = origin
            gtk.main()
            
    def window_moved(self,item):
        # Responding to main applet movement
        if item.mode == 0:
			print "Reorientating Orb top!! (Don't let this happen too often!!)"
			origin = self.applet.window.get_origin()
			Window_x =  origin[0] + Images.StartButtonXOffset
			Window_y =  origin[1] + Images.StartButtonYOffset
			self.screenmidpty = int(Images.screenheight / 2)
			if Window_y < self.screenmidpty:
				self.screenstate = 3
				Window_y = Window_y - 1
			else:
				self.screenstate = 0
			item.move(Window_x,Window_y)
        else:
            print "window_moved called during wrong mode"
        

